searchData={"items":[{"type":"module","title":"Horizon.Ops.BSD.Config","doc":"Horizon.Ops configuration.","ref":"Horizon.Ops.BSD.Config.html"},{"type":"function","title":"Horizon.Ops.BSD.Config.merge_default_options/2","doc":"Merge default options with release options.","ref":"Horizon.Ops.BSD.Config.html#merge_default_options/2"},{"type":"function","title":"Examples - Horizon.Ops.BSD.Config.merge_default_options/2","doc":"iex> merge_defaults([], \"foo\")\n      [\n        path: \"/usr/local/foo\",\n        bin_path: \"bin\",\n        build_path: \"/usr/local/opt/foo/build\",\n        releases_path: \".releases\",\n        build_host: \"HOSTUNKNOWN\",\n        build_user: \"$(whoami)\"\n      ]","ref":"Horizon.Ops.BSD.Config.html#merge_default_options/2-examples"},{"type":"function","title":"Horizon.Ops.BSD.Config.merge_defaults/1","doc":"Merge default options into release.options and\nset release.path and release.version_path.","ref":"Horizon.Ops.BSD.Config.html#merge_defaults/1"},{"type":"function","title":"Examples - Horizon.Ops.BSD.Config.merge_defaults/1","doc":"iex> releases = [my_app: [path: \"/usr/apps/my_app\"]]\n    iex> merge_defaults(releases)\n    [\n      my_app: [\n        bin_path: \"bin\",\n        build_path: \"/usr/local/opt/my_app/build\",\n        releases_path: \".releases\",\n        build_host: \"HOSTUNKNOWN\",\n        build_user: \"$(whoami)\",\n        path: \"/usr/my_app\"\n      ]\n    ]\n    iex> merge_defaults([my_app: []])\n    [\n      my_app: [\n        path: \"/usr/local/my_app\",\n        bin_path: \"bin\",\n        build_path: \"/usr/local/opt/my_app/build\",\n        releases_path: \".releases\",\n        build_host: \"HOSTUNKNOWN\",\n        build_user: \"$(whoami)\"\n      ]\n    ]","ref":"Horizon.Ops.BSD.Config.html#merge_defaults/1-examples"},{"type":"function","title":"Horizon.Ops.BSD.Config.merge_release/1","doc":"Merge default options into release.options and\nset release.path and release.version_path.","ref":"Horizon.Ops.BSD.Config.html#merge_release/1"},{"type":"module","title":"Horizon.Ops.BSD.Step","doc":"The Horizon.Ops..BSD.Step module contains steps that are used to\nperform tasks during the release process.\n\n- `setup/1` - Run all the needed release steps.\n- `echo/1` - Echo the release name and options to the console.\n- `merge_defaults/1` - Merges the Horizon.Ops defaults into the release options.\n- `setup_rcd/1` - Create the rc.d script for the release.","ref":"Horizon.Ops.BSD.Step.html"},{"type":"function","title":"Horizon.Ops.BSD.Step.echo/1","doc":"Echo the release name and options to the console.","ref":"Horizon.Ops.BSD.Step.html#echo/1"},{"type":"function","title":"Horizon.Ops.BSD.Step.merge_defaults/1","doc":"Merges the Horizon.Ops.BSD defaults into the release options.\n\nCalling this step will override Elixir's default value for\n`release.path` and `release.version_path`.","ref":"Horizon.Ops.BSD.Step.html#merge_defaults/1"},{"type":"function","title":"Horizon.Ops.BSD.Step.setup/1","doc":"Run the merge and rcd release steps.","ref":"Horizon.Ops.BSD.Step.html#setup/1"},{"type":"function","title":"Horizon.Ops.BSD.Step.setup_rcd/1","doc":"Create the rc.d script for the release.\nThis script is created `overlays/rc_d` and copied to `/usr/local/etc/rc.d/ `\nduring deploy.","ref":"Horizon.Ops.BSD.Step.html#setup_rcd/1"},{"type":"module","title":"Horizon.Ops.BSD.Utils","doc":"Horizon.Ops is a tool for building and deploying\nElixir applications to FreeBSD hosts.","ref":"Horizon.Ops.BSD.Utils.html"},{"type":"function","title":"Horizon.Ops.BSD.Utils.assigns/2","doc":"Assigns the application and options to a keyword list.","ref":"Horizon.Ops.BSD.Utils.html#assigns/2"},{"type":"function","title":"Horizon.Ops.BSD.Utils.get_config_releases/0","doc":"Returns the options, with defaults inserted, for each release.\nIf no releases are defined in the mix.exs file, a default release returned.\n\nThis is the configured options for releases that you set for\neach release in `mix.exs` and can be inspected with `Mix.Project.config()[:releases]`.\nNot to be confused with the `%Mix.Release{}` struct that is passed to each `Step`.\nThe options here are stored in the `Mix.Release.options` field.","ref":"Horizon.Ops.BSD.Utils.html#get_config_releases/0"},{"type":"function","title":"Horizon.Ops.BSD.Utils.get_src_path/2","doc":"","ref":"Horizon.Ops.BSD.Utils.html#get_src_path/2"},{"type":"function","title":"Horizon.Ops.BSD.Utils.get_src_tgt/2","doc":"Returns a tuple with the full source path and the target file name.\nFiles are referenced with an atom.\n\nNote that files in the `scripts` folder are expected to keep the same\nname from source to target. These static scripts will only be copied\nto the a `bin/` folder one time.","ref":"Horizon.Ops.BSD.Utils.html#get_src_tgt/2"},{"type":"function","title":"Examples - Horizon.Ops.BSD.Utils.get_src_tgt/2","doc":"iex> get_src_tgt(:stage, \"foo\")\n      {\"/path_to_horizon/priv/templates/bin/stage.sh.eex\", \"stage-foo.sh\"}","ref":"Horizon.Ops.BSD.Utils.html#get_src_tgt/2-examples"},{"type":"function","title":"Horizon.Ops.BSD.Utils.warn_is_missing_freebsd_alias/1","doc":"Validate that the `assets.setup.freebsd` alias exists in the mix.exs file.","ref":"Horizon.Ops.BSD.Utils.html#warn_is_missing_freebsd_alias/1"},{"type":"module","title":"Horizon.Ops.Target","doc":"ADT for Horizon.Ops deployment targets","ref":"Horizon.Ops.Target.html"},{"type":"function","title":"Horizon.Ops.Target.is_static?/1","doc":"","ref":"Horizon.Ops.Target.html#is_static?/1"},{"type":"function","title":"Horizon.Ops.Target.is_template?/1","doc":"","ref":"Horizon.Ops.Target.html#is_template?/1"},{"type":"type","title":"Horizon.Ops.Target.content_type/0","doc":"","ref":"Horizon.Ops.Target.html#t:content_type/0"},{"type":"type","title":"Horizon.Ops.Target.key/0","doc":"","ref":"Horizon.Ops.Target.html#t:key/0"},{"type":"type","title":"Horizon.Ops.Target.t/0","doc":"","ref":"Horizon.Ops.Target.html#t:t/0"},{"type":"module","title":"Horizon.Ops.Utils","doc":"Horizon.Ops is a tool for building and deploying\nElixir applications to FreeBSD hosts.","ref":"Horizon.Ops.Utils.html"},{"type":"function","title":"Horizon.Ops.Utils.copy_static_file/5","doc":"Copy a file from source to target, overwriting if necessary.","ref":"Horizon.Ops.Utils.html#copy_static_file/5"},{"type":"function","title":"Example - Horizon.Ops.Utils.copy_static_file/5","doc":"iex> safe_copy_file(:horizon_helpers, app, overwrite, false, opts, &Path.join(&2[:bin_path], &1))","ref":"Horizon.Ops.Utils.html#copy_static_file/5-example"},{"type":"function","title":"Horizon.Ops.Utils.create_file_from_template/7","doc":"Create a file from a template.","ref":"Horizon.Ops.Utils.html#create_file_from_template/7"},{"type":"function","title":"Example - Horizon.Ops.Utils.create_file_from_template/7","doc":"iex> create_file_from_template(\"source\", \"target\", true, false, %{}, &assigns/2, fn target, opts -> target end)","ref":"Horizon.Ops.Utils.html#create_file_from_template/7-example"},{"type":"function","title":"Horizon.Ops.Utils.safe_copy_file/4","doc":"Safely copy a file from source to target.","ref":"Horizon.Ops.Utils.html#safe_copy_file/4"},{"type":"function","title":"Example - Horizon.Ops.Utils.safe_copy_file/4","doc":"iex> safe_copy_file(\"source\", \"target\", true)\n        Created target","ref":"Horizon.Ops.Utils.html#safe_copy_file/4-example"},{"type":"function","title":"Horizon.Ops.Utils.safe_write/4","doc":"","ref":"Horizon.Ops.Utils.html#safe_write/4"},{"type":"function","title":"Horizon.Ops.Utils.validate_releases/1","doc":"Validate the releases configuration for nil values.","ref":"Horizon.Ops.Utils.html#validate_releases/1"},{"type":"function","title":"Examples - Horizon.Ops.Utils.validate_releases/1","doc":"iex> validate_releases([..., build_user: nil, ..])\n  releases #=> [\"phx_only -> build_user\", \"phx_only -> build_host\"]","ref":"Horizon.Ops.Utils.html#validate_releases/1-examples"},{"type":"task","title":"mix horizon.bsd.init","doc":"Creates Horizon.Ops deploy scripts in `bin/` and `rel/` directories.","ref":"Mix.Tasks.Horizon.Bsd.Init.html"},{"type":"task","title":"Usage - mix horizon.bsd.init","doc":"mix horizon.bsd.init [-y]","ref":"Mix.Tasks.Horizon.Bsd.Init.html#module-usage"},{"type":"task","title":"Options - mix horizon.bsd.init","doc":"* `-y` - Overwrite files without asking for confirmation.","ref":"Mix.Tasks.Horizon.Bsd.Init.html#module-options"},{"type":"task","title":"Description - mix horizon.bsd.init","doc":"Horizon.Ops.Bsd.init creates several scripts for deploying an Elixir application to a host.\nHorizon.Ops.Bsd is customized for FreeBSD hosts. Use Horizon.Oos.Linux for Linux hosts.","ref":"Mix.Tasks.Horizon.Bsd.Init.html#module-description"},{"type":"task","title":"Customization - mix horizon.bsd.init","doc":"Horizon.Ops.Bsd.init uses the `releases` configuration in `mix.exs` to customize the deployment scripts.\nThe available options are:\n\n- `bin_path`: default :`bin`\n- `path`: default: `/usr/local/ `\n- `build_user`: default: `whoami`\n- `build_host`: default: `HOSTUNKNOWN`\n- `deploy_user`: default: `whoami`\n- `deploy_host`: default: `HOSTUNKNOWN`\n- `release_commands`: default: `[]`\n- `releases_path`: default: `.releases`\n\n#### `bin_path`\n\nThe directory where the scripts are created. If there is a `bin_path` for each release, scripts\nare copied to each bin directory.\n\n#### `path`\n\nThe final destination of the release on the deploy host. This will be the same on deploy only hosts and the build host.\n\n#### `build_user`\n\nThe username on the build machine. This is used to copy the release to the build machine.\nThis is used by the `stage` script to copy the release to the build machine, but may be overridden\non the commandline.\n\n#### `build_host`\n\nThe hostname of the build machine. This is used to copy the release to the build machine.\nThis is used by the `stage` script to copy the release to the build machine, but may be overridden\non the commandline.\n\n#### `deploy_user`\n\nThe username on the deploy machine. This is used to copy the release to the deploy machine.\n\n#### `deploy_host`\n\nThe hostname of the deploy machine. This is used to copy the release to the deploy machine.\n\n#### `release_commands`\n\nA list of commands to run after the release is copied to the deploy machine.\nThese commands should be `0` arity functions in Release.ex.\n\n#### `releases_path`\n\nThe directory where releases are stored on the local host.\nThe build script places the release tarball in this directory and the deploy\nscript copies the release from this directory.","ref":"Mix.Tasks.Horizon.Bsd.Init.html#module-customization"},{"type":"task","title":"Files Created - mix horizon.bsd.init","doc":"Running `mix horizon.init` creates several files in the `bin_path` directory.\nFor the project `my_app`, these files include:\n\n- `bsd_install.sh`\n- `bsd_install_args.sh`\n- `bsd_install_script.sh`\n- `horizon_helpers.sh`\n- `release-my_app.sh`\n- `build-my_app.sh`\n- `stage-my_app.sh`\n- `deploy-my_app.sh`\n- `deploy_script-my_app.sh`\n\nIf you have multiple releases, a `stage`, and `build` and `deploy` script\nis created for each release.\nFor example, imagine you have releases `app_web` and `app_worker`.\nHorizon.Ops.BSD.init will create\n\n- `bin/stage-app_web.sh`\n- `bin/stage-app_worker.sh`\n- `bin/build-0app_web.sh`\n- `bin/build-0app_worker.sh`\n- `bin/deploy-app_web.sh`\n- `bin/deploy-app_worker.sh`\n\nAn rc.d script is created in `rel/overlays/rc_d/` for each release.","ref":"Mix.Tasks.Horizon.Bsd.Init.html#module-files-created"},{"type":"extras","title":"Horizon","doc":"# Horizon\n\nWelcome to **Horizon**, an Ops library for deploying Elixir/Phoenix\nprojects. Horizon lets you stage, build, and deploy your Elixir/Phoenix\napp in minutes. Horizon also has tools for standing up a Postgres server\nwith continual backups and drive replication via `zfs` snapshots. \n\nFull control of your ops environment is at your fingertips. \n\nWith the Power to Serve, Horizon's first ops platform is FreeBSD.\n\nNo special tools are required for host configuration or release management\nother than SSH access to the host. (Release management is done through `/bin/sh` scripts.\n\nThe BSD host configuration includes a `bsd_install.sh` script that facilitates installing FreeBSD packages, building Elixir from source, enabling and starting services, installing and configuring PostgreSQL, and creating databases.\n\nRelease management involves **three steps**:\n** staging** of the source code to the build server\n** building** the release tarball on the build server\n** deploying** a tarball to the deploy server and starting the application service\n\n```mermaid\ngraph LR\n A[Horizon.Ops.init] --> B[STAGE]\n B --> C[BUILD]\n C --> D[DEPLOY]\n```\n\nIn addition to easy host management and rapid deployments, Horizon.Ops was motivated to help facilitate Phoenix deployments for platforms other than your development platform, e.g., MacOS -> FreeBSD or MacOS -> Linux.","ref":"readme.html"},{"type":"extras","title":"Installation - Horizon","doc":"(TBD) Add `horizon` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n [\n    {:horizon, \"~> 0.1.2\", runtime: false}\n # {:horizon, github: \"jfreeze/horizon\", runtime: false}\n ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Add a Release to mix.exs - Horizon","doc":"Horizon.Ops requires a `release` to be defined in `mix.exs`. \n```elixir\n  def project do\n    [\n      app: :my_app,\n      ...,\n      releases: [\n        my_app: [\n          applications: [runtime_tools: :permanent],\n          include_executables_for: [:unix],\n          build_user: System.get_env(\"BUILD_USER\"),\n          build_host: System.get_env(\"BUILD_HOST\"),\n          deploy_host: System.get_env(\"DEPLOY_HOST\"),\n          deploy_user: System.get_env(\"DEPLOY_USER\"),\n          # releases_path: \".releases\",\n          # bin_path: \"bin\",\n          # build_path: \"/usr/local/opt/my_app/build\",\n          # app_path: \"/usr/local/my_app\",\n          # release_commands: [],\n          steps: [\n            &Horizon.Ops.BSD.Step.setup/1,\n            :assemble,\n            :tar\n          ],\n          # cookie: System.fetch_env(\"RELEASE_COOKIE\")\n        ]\n      ]\n    end\n```\n\nRunning `mix horizon.bsd.init` creates scripts for each `release`. FreeBSD customary defaults are used for installation paths and are added when you include `&Horizon.Ops.BSD.Step.setup/1` as the first step of each release.\n\nNote: `assemble` is required to create your release target. `tar` is needed to build a tarball for deployment.","ref":"readme.html#add-a-release-to-mix-exs"},{"type":"extras","title":"Tailwind - Horizon","doc":"A typical `assets.setup` looks like:\n\n```\n\"assets.setup\": [\n   \"tailwind.install --if-missing\",\n   \"esbuild.install --if-missing\"\n],\n```\n\nHowever, since a tailwind download for FreeBSD is not currently provided by the Tailwind project, the `tailwind.install` supports passing a URL from which to download the app. \n\nAdd the following to your `mix.exs` file.\n\n```\n@tailwindcss_freebsd_x64 \"https://people.freebsd.org/~dch/pub/tailwind/v$version/tailwindcss-$target\"\n\n...\ndefp aliases do\n  [\n    ...\n    \"assets.setup.freebsd\": [\n      \"tailwind.install #{@tailwindcss_freebsd_x64}\",\n      \"esbuild.install --if-missing\"\n    ],\n    ...\n  ]\nend\n```","ref":"readme.html#tailwind"},{"type":"extras","title":"Env vars - Horizon","doc":"Running `mix release.init` creates a `rel/` directory that contains the file `env.sh.eex`. The simplest way to manage env vars is to add them directly to `env.sh.eex`:\n\n```\n...\nexport SECRET_KEY_BASE=5HPxy5qOJ...\nexport PHX_SERVER=true\n...\n```\n\nIf you are using a `.env` file for environment variables, one method is just to add it to your `env.sh.eex` file:\n\n```\ncat .env >> rel/env.sh.eex\n```\n\nOr, you can reference the `.env` file from within your `env.sh.eex` file.\n\n```shell\nenv_file=/usr/local/my_app/.env\nchmod 600 $env_file\n. $env_file\n```\n\nYou will need to add `.env` to your deploy artifacts. One solution is to copy the .env file to your `overlays` folder in `rel/overlays/.env`.\n\nHowever, this method may be insufficient since it would be the same `.env` file for all deploys. Writing a `Step` or a more sophisticated overlay that is version dependent may be required if not using `env.sh.eex`.","ref":"readme.html#env-vars"},{"type":"extras","title":"Deploying with Horizon.Ops - Horizon","doc":"To deploy your Elixir/Phoenix app, create your `Horizon.Ops` helper scripts with\n\n```shell\nmix horizon.bsd.init\n```\n\n**Note, you must run `horizon.bsd.init` to update your scripts every time you change `release` in `mix.exs`.**\n\nNote, that you can have a different `bin` folder for each release. \n\nAssuming you have used the default `bin` folder for your project, the release steps would look like:\n\n```shell\n# transfer existing code state to build server\n./bin/stage-my_app.sh --force\n\n# build your app on the build server and \n# copy the tarball to .releases/\n./bin/build-my_app.sh\n\n# deploy the release\n./bin/deploy-my_app.sh\n```\n\nThat's it.\n\nIf you need to deploy to multiple hosts, you can specify the user and host with the `-u` and `-h` options:\n\n```\n./bin/deploy-my_app.sh -u me -h example.com\n```\n\nNote: Since your beam application is a script and not a binary executable, stopping an app that started using the default Elixir release code will timeout. `Horizon.Ops` fixes this by creating a run command file in `/usr/local/etc/rc.d/my_app`. On FreeBSD, the default script for running **`remote`** or **`eval`** is fine, but for starting/stopping the service, you should use:\n\n```shell\n# service my_app start|stop|restart|status\n```\n\nDefault script usage (`eval`, `rpc`, `remote` ok to use):\n```\nUsage: my_app COMMAND [ARGS]\n\nThe known commands are:\n\n  start          Starts the system\n  start_iex      Starts the system with IEx attached\n  daemon         Starts the system as a daemon\n  daemon_iex     Starts the system as a daemon with IEx attached\n  eval \"EXPR\"    Executes the given expression on a new, non-booted system\n  rpc \"EXPR\"     Executes the given expression remotely on the running system\n  remote         Connects to the running system via a remote shell\n  restart        Restarts the running system via a remote command\n  stop           Stops the running system via a remote command\n  pid            Prints the operating system PID of the running system via a remote command\n  version        Prints the release name and version to be booted\n```","ref":"readme.html#deploying-with-horizon-ops"},{"type":"extras","title":"Host Configuration - Horizon","doc":"The above deployment example assumes you have a running build, deployment, and database host. If you don't, never fear. `Horizon.Ops` can help you build these in minutes.\n\nThe sample configuration files were used on a FreeBSD 14.1 base install. The only requirements for the base installation by Horizon.Ops are that they have `doas` installed and configured.\n\n```shell\n# pkg install -y doas\ndoas echo \"permit nopass setenv { -ENV PATH=$PATH LANG=$LANG LC_CTYPE=$LC_CTYPE } :wheel\" > /usr/local/etc/doas.conf\n```","ref":"readme.html#host-configuration"},{"type":"extras","title":"Sample Build Host Configuration - Horizon","doc":"This is a sample configuration file for a build host.  The only expectation for this host is to build a release but not run the application.\n\n`#build.conf`\n```\n#\n# Setup for an Elixir/Pheonix FreeBSD build host\n#\n\npkg:ca_root_nss\npkg:gcc\npkg:gmake\npkg:git\npkg:rsync\npkg:erlang-runtime27\n\n# Store the path to erlang for builds\ndot-path:/usr/local/lib/erlang27/bin\n\n# Set the path to erlang so we can install elixir\npath:/usr/local/lib/erlang27/bin\n\nelixir:1.17.3\n```\n\nTo install this script run:\n\n```\n./bin/bsd_install.sh -u me target_host build.conf\n```","ref":"readme.html#sample-build-host-configuration"},{"type":"extras","title":"Sample Web Host Configuration - Horizon","doc":"A web host has minimal configuration because we ship the Erlang runtime in the deployments. This allows you to update the Elixir version on deployments.\n\nThis example assumes the app needs `vips` for use with `vix`. (not tested.)\n\n`#web.conf`\n```\npkg:vips\n```\n\nInstall with:\n\n```\n./bin/bsd_install.sh -u me target_host web.conf\n```","ref":"readme.html#sample-web-host-configuration"},{"type":"extras","title":"Sample Postgres Host Configuration - Horizon","doc":"Keeping your Postgres server on a separate server is a good idea. This allows it to have its own upgrade process and simplifies mirroring and migration. You can install Postgres on the same host as the web host and even on the build host.\n\nThere are three steps to getting Postgres up and running:\n\n1. Install the version of postgres server and contrib library of your choice\n2. Initialize `postgresql`. This configures `postgresql.conf`, `pg_hba.conf` and logging. Logging is at `/var/log/postgresql.log`\n3. Create a database. Creating a database creates a user/password, and updates `pg_hba.conf`. You can also choose the locale and `ctype` of the database.\n- postgres-db-c_mixed_utf8\n- postgres-db-c_utf8_full\n- postgres-db-us_utf8_full\n\n`#postgres.conf`\n```\npkg:postgresql16-server\npkg:postgresql16-contrib\npostgres.init\n\n# Encode with UTF8 and sort with byte order\npostgres.db:c_mixed_utf8:mydb\n\n# Other postgresql options\n#postgres.db:us_utf8_full:mydb\n#postgres.db:c_utf8_full:mydb\n```\n\nInstall with:\n\n```\n./bin/bsd_install.sh -u me target_host postgres.conf\n```\n\nWith hosts configured, you can now build and deploy an Elixir app.\n\n- Staging copies the app source to the build machine.\n- Building creates a tarball that is ready to run on a deploy host.\n- Deploy copies the tarball to the build machine and starts the service. (Future: JEDI can allow hot deploys to a running service.)","ref":"readme.html#sample-postgres-host-configuration"},{"type":"extras","title":"Horizon.Ops.BSD Release Steps in Detail - Horizon","doc":"Here is a summary of the actions taken in each release step.","ref":"readme.html#horizon-ops-bsd-release-steps-in-detail"},{"type":"extras","title":"Stage - Horizon","doc":"- Uses `rsync` or `tar/scp` to copy the current project state to the build host","ref":"readme.html#stage"},{"type":"extras","title":"Build - Horizon","doc":"- checks if `tailwind` is available and downloads it if needed.\n- installs `mix local.hex`\n- runs `mix deps.get`\n- runs `mix assets.setup.freebsd`\n- runs `mix phx.digest.clean --all`\n- runs `mix assets.deploy`\n- runs `mix release`\n  - Calls `Horizon.Ops.BSD.Step.setup/1` that creates the rcd script\n- stores the tarball in .releases\n- stores the tarball name in `.releases/my_app.data`","ref":"readme.html#build"},{"type":"extras","title":"Deploy - Horizon","doc":"- adds `my_app_enable=\"YES\"` to `/etc/rc.conf`\n- expands the tarball\n- sets `env.sh` to mode 0400.\n- creates user 'my_app' if it doesn't exist\n- moves rcd script to `/usr/local/etc/rc.d/my_app`\n- runs any optional release commands\n- runs `doas service my_app restart`\n\nApps are started with the user that has the same name as the app.\nFor example, the release `my_app` will be run as the user `my_app`.\nThis allows multiple Elixir/Phoenix apps to reside on the same\nserver, each isolated from the other and individually controlled\nwith the `service` command.\n\n[![License](https://img.shields.io/badge/license-MIT-blue.svg)](LICENSE)\n\n---","ref":"readme.html#deploy"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}